/*------------------------------------------------------------------------------
  File:        fw/link/fw-custref-wminfo.p
  Doel:        Customer references van SFI's automatisch bijwerken 
  Parameters:  via fw-controlcodes: 

               
  Notes:       Voorwaarde 
               1) SFI is aangemaakt 
               2) WM Project is aangemaakt en gekoppeld met SFI 
               3) Intake orders / lines zijn aangemaakt en gekoppeld met project 
               4) Custref wordt alleen bijgesteld als deze leeg is 
                  
------------------------------------------------------------------------------*/

DEFINE INPUT PARAMETER pcCompanyCode     AS CHARACTER NO-UNDO.
DEFINE INPUT PARAMETER pcUserid          AS CHARACTER NO-UNDO.
DEFINE INPUT PARAMETER phFrameHandle     AS HANDLE    NO-UNDO.
DEFINE VARIABLE        pETA              AS DATE        NO-UNDO.
DEFINE VARIABLE        cCustRef          AS CHARACTER   NO-UNDO.
DEFINE VARIABLE        minInOrdnr        AS INTEGER     NO-UNDO.
DEFINE VARIABLE        maxInOrdnr        AS INTEGER     NO-UNDO.
DEFINE VARIABLE        cOrigin           AS CHARACTER   NO-UNDO.
DEFINE VARIABLE        cProduct          AS CHARACTER   NO-UNDO.


/*spCompany  = 'ZZC'. */
pETA       = 08/01/2020. 
cCustRef   = ''. 
minInOrdnr = 0.
maxInOrdnr = 0. 


FOR EACH  fw-dossier 
    WHERE fw-dossier.companycode  = pcCompanyCode 
    AND   fw-dossier.typecode     = 'SFI'
    AND   fw-dossier.date-create >= pETA
    :

    FOR EACH  wm-project 
        WHERE wm-project.companycode = pcCompanyCode
        AND   wm-project.fw_in_dossier = fw-dossier.dossiernr
        NO-LOCK: 

        FOR EACH wm-in_line
            WHERE wm-in_line.companycode = pcCompanyCode
            AND   wm-in_line.projectnr   = wm-project.projectnr 
            NO-LOCK: 

            FIND wm-in_ord
                 WHERE wm-in_ord.companycode = pcCompanyCode
                 AND   wm-in_ord.in_ordnr    = wm-in_line.in_ordnr 
                 NO-LOCK NO-ERROR. 

            FIND wm-product 
                 WHERE wm-product.product_id = wm-in_line.product_id
                 NO-LOCK NO-ERROR. 

            /* componenten bepalen voor Custref: 
               eerste-custref_in1 t/m laatste-custref_in1 
               Origin
               Product 
               */ 
            IF cCustRef   = '' THEN cCustRef   = wm-in_line.custref_in1. 
            IF minInOrdnr = 0  THEN minInOrdnr = wm-in_line.in_ordnr. 
            maxInOrdnr    = wm-in_line.in_ordnr. 
            cOrigin       = wm-in_ord.origin_countrycode . 
            cProduct      = wm-product.des. 

        END.

        
        IF minInordnr <> maxInOrdnr THEN cCustRef = cCustRef + '-' + SUBSTRING(STRING(maxInOrdnr, '99999999'), 6,3). 
        cCustRef = cCustRef + ' ' + cOrigin + ' ' + cProduct. 
        IF fw-dossier.cust_ref = '' THEN  fw-dossier.cust_ref = cCustRef. 
        
        /* reset alles */ 
        cCustRef = ''. 
        minInOrdnr = 0.
        maxInOrdnr = 0. 
        cOrigin = ''.
        cProduct = ''. 
                    
    END.

END.
